/*******************************************************************
HILBEX
version 0.1, 1 Oct 2016

This file is part of the software package Hilbex by Herman
Haverkort. Use and distribution of this software is subject to
restrictions. Consult readme.txt for details, or download it from
http://spacefillingcurves.net/.
*******************************************************************/

#ifndef HILBERT3DSUITE_CURVE
#define HILBERT3DSUITE_CURVE

#include "traversal.h"
#include "search.h"
#include "properties.h" 
#include "options.h"

typedef long long int int64;

class Hilbert3DCurve: public RecursiveTraversal
{
  private:
    string theName;
    Properties properties;
    void analyseGates();
    void analyseTraversal(const OutputLevel testLevel = Concise);
    void analyseTransformations(const OutputLevel testLevel = Concise);
    
  public:
    Hilbert3DCurve(Hilbert3DCurveSearch& search, const OutputLevel testLevel = Concise);
    bool is(Property p) const;
    bool isNot(Property p) const;
    string name() const;
    string shortName() const;
    string propertyTable() const;
    string info(ifstream* curveInfo = 0) const;
    
  friend Hilbert3DCurveSearch;    
};

ifstream curveInfo("curveinfo.txt");

#endif

