/*******************************************************************
HILBEX
version 0.1, 1 Oct 2016

This file is part of the software package Hilbex by Herman
Haverkort. Use and distribution of this software is subject to
restrictions. Consult readme.txt for details, or download it from
http://spacefillingcurves.net/.
*******************************************************************/

#ifndef HILBERT3DSUITE_FILTER
#define HILBERT3DSUITE_FILTER

#include <algorithm>
#include "properties.h"

class Filter
{
  private:
    string prefix;
    LimitedTraversal traversal;
    Properties properties;
    void parse(const string& specification, const Filter& commonFilter);
  public:
    Filter();
    Filter(const string& specification, const Filter& commonFilter = Filter());
    Filter(istream& specification, const Filter& commonFilter = Filter());
    bool consistent() const;
    bool requires(Property p) const;
    bool forbids(Property p) const;
    bool matchTraversal(const RecursiveTraversal& r, Transformation& t) const;
    string name() const;
};

#endif

