/*******************************************************************
HILBEX
version 0.1, 1 Oct 2016

This file is part of the software package Hilbex by Herman
Haverkort. Use and distribution of this software is subject to
restrictions. Consult readme.txt for details, or download it from
http://spacefillingcurves.net/.
*******************************************************************/

#ifndef HILBERT3DSUITE_PROPERTIES
#define HILBERT3DSUITE_PROPERTIES

#include <bitset>
using std::bitset;

const int nrProperties = 21; // including "invalid", for debugging

enum Property {
  FaceContinuous, Hyperorthogonal,
  Symmetric, Metasymmetric,
  FacetHarmonious, DiagonalHarmonious,
  WellFolded,
  VertexGated, VertexEdgeGated, VertexFacetGated, EdgeGated, FacetGated, 
  EdgeCrossing, FacetCrossing, CubeCrossing,
  Centred,                 
  OrderPreserving, PatternIsotropic, CoordinateShifting, Standing,
  Invalid
};

class Properties
{
  private:
    bitset<nrProperties> confirmed;
    bitset<nrProperties> rejected;
    Property parse(string word);
  public:
    static const string acronym[21];
    static const string name[21];
    Properties();
    void confirm(Property p);
    void confirm(string p);
    void reject(Property p);
    void reject(string p);
    bool is(Property p) const;
    bool isNot(Property p) const;
    string table() const;
    string report() const;
};

#endif

