/*******************************************************************
HILBEX
version 0.1, 1 Oct 2016

This file is part of the software package Hilbex by Herman
Haverkort. Use and distribution of this software is subject to
restrictions. Consult readme.txt for details, or download it from
http://spacefillingcurves.net/.
*******************************************************************/

#ifndef (WireSettings)
#declare CubeWidth = pow(2, Order);
#declare WhiteWall = texture 
{ 
  pigment { color red 1 green 1 blue 1 }
}
#macro Section(prev, curr, next, tvalue)
  sphere_sweep {
    linear_spline
    3,
    (prev + curr)/2, TubeWidth
    curr, TubeWidth
    (curr + next)/2, TubeWidth
    texture {
      pigment { Colour(tvalue) }
      finish {
        brilliance 3
        diffuse 0.85
        metallic
        specular 0.40
        roughness 1/60
        reflection 0.05
      }
    }
  }
#end

global_settings {
  assumed_gamma 1.0
  radiosity {
    pretrace_start 0.08
    pretrace_end   0.04
    count 100

    nearest_count 5
    error_bound 0.03
    recursion_limit 2

    low_error_factor .5
    gray_threshold 0.0
    minimum_reuse 0.015
    brightness 1

    adc_bailout 0.01/2
  }
}

camera {
  location < -2.0*CubeWidth, 4.0*CubeWidth, -5.0*CubeWidth >
  look_at < 0.86*CubeWidth, 0, CubeWidth >
  angle 20
  #ifdef (Focus)
  focal_point < 0.25*CubeWidth, 1.0*CubeWidth, 0*CubeWidth >
  aperture 0.4
  blur_samples 7
  #end
}

light_source {
  < 0.6*CubeWidth, 2.5*CubeWidth, -1.50*CubeWidth >
  color red 2.0 green 2.0 blue 2.0  
  area_light <1.43*CubeWidth, 0, 0>, <0, 0, 1.43*CubeWidth>, 5, 5
  adaptive 1
  jitter
}

box { < -1000*CubeWidth, -0.2, -1000*CubeWidth >, < 1001*CubeWidth, -0.1,  1001*CubeWidth > texture { pigment { color BackgroundColour } } }

#declare WireSettings = 1;
#end

#ifndef (NoBox)
box { < 0, -0.1, 0 >, < CubeWidth, 0, CubeWidth > texture { WhiteWall } }
box { < 0, -0.1, CubeWidth >, < CubeWidth+0.1, CubeWidth, CubeWidth+0.1 > texture { WhiteWall } }
box { < CubeWidth, -0.1, 0 >, < CubeWidth+0.1, CubeWidth, CubeWidth+0.1 > texture { WhiteWall } }
#end

